import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.lang.management.ManagementFactory;
import java.lang.management.ThreadMXBean;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;

public class NIO {
	
	public static void main(String[] args) {
		final ThreadMXBean bean = ManagementFactory.getThreadMXBean();
		if (args.length != 1) {
			System.out.println("Uso: IO <nomearquivo>");
			return;
		}
		
		try {
			FileInputStream fis = new FileInputStream(args[0]);
			FileOutputStream fos = new FileOutputStream("res_io.txt");
			
			FileChannel in = fis.getChannel();
			FileChannel out = fos.getChannel();
			
			ByteBuffer buffer = ByteBuffer.allocateDirect(32 * 1024);
			
			// Now loop until no more bytes to read and the buffer is empty
			while (in.read(buffer) != -1 || buffer.position() > 0) {
				// The read() call leaves the buffer in "fill mode". To prepare
				// to write bytes from the bufferwe have to put it in
				// "drain mode"
				// by flipping it: setting limit to position and position to
				// zero
				buffer.flip();
				
				// Now write some or all of the bytes out to the output channel
				out.write(buffer);
				
				// Compact the buffer by discarding bytes that were written,
				// and shifting any remaining bytes. This method also
				// prepares the buffer for the next call to read() by setting
				// the
				// position to the limit and the limit to the buffer capacity.
				buffer.compact();
			}
			
			in.close();
			out.close();
			fis.close();
			fos.close();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
		
		System.out.printf("%.5f\n",
						  (double) bean.getCurrentThreadCpuTime() / 1000000000.0);
	}
	
}
