
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.lang.management.ManagementFactory;
import java.lang.management.ThreadMXBean;

public class Ordenar {

	public static void main(String[] args) throws IOException {
		if (args.length != 2) {
			System.out
					.println("USO: ORDENAVETOR <NOME_ARQUIVO_ORIGEM> <METODO_ORDENACAO>.\n");
			System.out
					.println("     <METODO_ORDENACAO>: SELECAO|BOLHA|INSERCAO\n");
			System.exit(-1);
		}

		String nomeArquivoOrigem = args[0];
		final String metodoOrdenacao = args[1];

		final int vetor[] = leArquivoOrigem(nomeArquivoOrigem);
		Thread t = new Thread(){
			
			@Override
			public void run() {
				final ThreadMXBean bean = ManagementFactory.getThreadMXBean();
				if (metodoOrdenacao.equals("SELECAO")) {
					selecao(vetor, vetor.length - 1);
				} else if (metodoOrdenacao.equals("BOLHA")) {
					bolha(vetor, vetor.length - 1);
				} else if (metodoOrdenacao.equals("INSERCAO")) {
					insercao(vetor, vetor.length - 1);
				}
				System.out.printf("%.5f\n", (double)bean.getCurrentThreadCpuTime()/1000000000.0);
			}
			
		};
		
		t.setDaemon(false);
		t.start();
	}

	private static int[] leArquivoOrigem(String nomeArquivoOrigem)
			throws IOException {
		File f = new File(nomeArquivoOrigem);
		FileReader reader = new FileReader(f);
		BufferedReader bf = new BufferedReader(reader);
		int tam = Integer.parseInt(bf.readLine());
		String numeros = bf.readLine();

		int v[] = new int[tam + 1];
		v[0] = 0;
		int i = 1;
		for (String num : numeros.split(" ")) {
			v[i++] = Integer.parseInt(num);
		}
		bf.close();
		reader.close();
		return v;
	}

	public static void selecao(int vetor[], int qtdePosicao) {
		int i, j, min, aux;
		for (i = 1; i <= qtdePosicao - 1; i++) {
			min = i;
			for (j = i + 1; j <= qtdePosicao; j++) {
				if (vetor[j] < vetor[min]) {
					min = j;
				}
			}
			aux = vetor[min];
			vetor[min] = vetor[i];
			vetor[i] = aux;
		}
	}

	public static void bolha(int vetor[], int qtdePosicao) {
		int i, j, aux;
		for (i = 1; i <= qtdePosicao - 1; i++) {
			for (j = i + 1; j <= qtdePosicao; j++) {
				if (vetor[j] < vetor[i]) {
					aux = vetor[j];
					vetor[j] = vetor[i];
					vetor[i] = aux;
				}
			}
		}
	}

	private static void insercao(int[] vetor, int qtdePosicao) {
		int i, j, aux;
		for (i = 2; i <= qtdePosicao; i++) {
			aux = vetor[i];
			j = i - 1;
			vetor[0] = aux; /* Sentinela */
			while (aux < vetor[j]) {
				vetor[j + 1] = vetor[j];
				j--;
			}
			vetor[j + 1] = aux;
		}
	}
}
