
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.lang.management.ManagementFactory;
import java.lang.management.ThreadMXBean;

public class Pesquisar {
	public static void main(String[] args) throws IOException {
		if (args.length != 3) {
			System.out
					.println("USO: ORDENAVETOR <NOME_ARQUIVO_ORIGEM> <METODO_PESQUISA> <NUMERO>.\n");
			System.out
					.println("     <METODO_ORDENACAO>: SEQUENCIAL\n");
			System.exit(-1);
		}

		String nomeArquivoOrigem = args[0];
		final String metodoPesquisa = args[1];
		final int valorProcurado = Integer.parseInt(args[2]);

		//long inicio = System.nanoTime();
		final int vetor[] = leArquivoOrigem(nomeArquivoOrigem);
		//System.out.println((System.nanoTime()-inicio)/1000000000.0);
		Thread t = new Thread(){
			
			@Override
			public void run() {
				int result = -1;
				final ThreadMXBean bean = ManagementFactory.getThreadMXBean();
				if (metodoPesquisa.equals("SEQUENCIAL")) {
					for (int i=0; i<100;i++){ //Para ser 1000g
						result = sequencial(vetor, vetor.length - 1, valorProcurado+45);
					}
				}
				System.out.printf("%d;%.5f\n",result,((double)bean.getCurrentThreadCpuTime())/1000000000.0);
			}
		};
		
		t.setDaemon(false);
		t.start();
	}

	private static int sequencial(int vetor[], int qtdePosicao, int valorProcurado){
		int i;
		for (i=0; i<qtdePosicao; ++i) {
			if (vetor[i]==valorProcurado){
				return i;
			}
		}
		return -1;
	}
	
	private static int[] leArquivoOrigem(String nomeArquivoOrigem)
			throws IOException {
		File f = new File(nomeArquivoOrigem);
		FileReader reader = new FileReader(f);
		BufferedReader bf = new BufferedReader(reader);
		int tam = Integer.parseInt(bf.readLine());
		String numeros = bf.readLine();

		int v[] = new int[tam + 1];
		v[0] = 0;
		int i = 1;
		for (String num : numeros.split(" ")) {
			v[i++] = Integer.parseInt(num);
		}
		bf.close();
		reader.close();
		return v;
	}
}
