import java.lang.management.ManagementFactory;
import java.lang.management.ThreadMXBean;


public class Simula {

	public static void main(String[] args) {
		final ThreadMXBean bean = ManagementFactory.getThreadMXBean();
		
		int v1[][] = new int[200][200];
		int v2[][] = new int[200][200];
		int res[][] = new int[200][200];
		int vetor[] = new int[40000];
		int count = 0;
		
		inicializa(v1,v2);
		
		mult(v1, v2, res);
		
		for (int i=0; i<res.length; i++){
			for (int j=0; j<res[i].length; j++){
				vetor[count++] = res[i][j];
			}
		}
		
		selecao(vetor, vetor.length);
		
		int x = sequencial(vetor, vetor.length, 19);
		
		System.out.printf("%d;",x);
		System.out.printf("%.5f\n", (double)bean.getCurrentThreadCpuTime()/1000000000.0);
	}
	
	private static void inicializa(int[][] v1, int[][]v2) {
		int count = 0;
		for (int i=0; i<v1.length; i++){
			for (int j=0; j<v1[i].length; j++){
				int aux = ++count%30;
				v1[i][j] = fat(aux);
				v2[i][j] = fib(aux);
			}
		}
		
	}

	private static void mult(int[][] v1, int[][]v2, int[][] res) {
		int i, j, k, TAM = v1.length;

		for (i = 0; i < TAM; i++) {
			for (j = 0; j < TAM; j++) {
				res[i][j] = 0;
				for (k = 0; k < TAM; k++) {
					res[i][j] += v1[i][k] * v2[k][j];
				}
			}
		}
	}
	
	private static int fat(int n) {
		if (n == 0 || n == 1) {
			return 1;
		}

		return n * fat(n - 1);
	}
	
	private static int fib(int n) {
		if (n == 0 || n == 1) {
			return n;
		}

		return fib(n - 1) + fib(n-2);
	}
	
	public static void selecao(int vetor[], int qtdePosicao) {
		int i, j, min, aux;
		for (i = 0; i < qtdePosicao; i++) {
			min = i;
			for (j = i + 1; j < qtdePosicao-1; j++) {
				if (vetor[j] < vetor[min]) {
					min = j;
				}
			}
			aux = vetor[min];
			vetor[min] = vetor[i];
			vetor[i] = aux;
		}
	}
	
	private static int sequencial(int vetor[], int qtdePosicao, int valorProcurado){
		int i;
		for (i=0; i<qtdePosicao; i++) {
			if (vetor[i]==valorProcurado){
				return i;
			}
		}
		return -1;
	}
	
}
