#include <stdio.h>
#include <stdlib.h>
#include <sys/resource.h>


int main (int argc, char** argv){
    struct rusage resources;
    int rc;
    double utime, stime, total_time;
	int i, j, k, tam;
	int **v1, **v2, **res;
	
	if (argc!=2){
		printf("Uso: mult <tam>");
		return -1;
	}
	
	tam = atoi(argv[1]);
	
	v1 = (int **) malloc (sizeof(int*) * tam);
	v2 = (int **) malloc (sizeof(int*) * tam);
	res = (int **) malloc (sizeof(int*) * tam);	
	
	for (i=0; i<tam;i++){
		v1[i] = (int *) malloc (sizeof(int) * tam);
		v2[i] = (int *) malloc (sizeof(int) * tam);
		res[i] = (int *) malloc (sizeof(int) * tam);		
	}
	
	for (i=0;i<tam;i++){
		for (j=0; j<tam; j++){
			v1[i][j] = v2[i][j] = (i+j); 
		}
	}
	
	for (i=0;i<tam;i++){
		for (j=0; j<tam; j++){
			res[i][j] = 0;
			for( k = 0; k < tam; k++){
				res[i][j] += v1[i][k] * v2[k][j];
			}	
		}
	}
    
    if((rc = getrusage(RUSAGE_SELF, &resources)) != 0)
        perror("getrusage failed");

    utime = (double) resources.ru_utime.tv_sec + 1.e-6 * (double) resources.ru_utime.tv_usec;
    stime = (double) resources.ru_stime.tv_sec + 1.e-6 * (double) resources.ru_stime.tv_usec;
    total_time = utime+stime;
    printf("%.5lf\n",total_time);

    return 0;
}
