#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <sys/resource.h>

/*Assinaturas*/
void selecao(int* vetor, int qtdePosicao);
void bolha(int* vetor, int qtdePosicao);
void insercao(int* vetor, int qtdePosicao);
void leArquivoOrigem(char *nomeArquivoOrigem, int** vetor, int *qtdePosicao);

int main(int argc, char *argv[]){
  char *nomeArquivoOrigem, *metodoOrdenacao;
  int qtdePosicao;
  int i=0,j;
  int* vetor;
  struct rusage resources;
  int rc;
  double utime, stime, total_time;
  
  if (argc!=3){
     printf("USO: ORDENAVETOR <NOME_ARQUIVO_ORIGEM> <METODO_ORDENACAO>.\n");     
     printf("     <METODO_ORDENACAO>: SELECAO|BOLHA|INSERCAO|QUICKSORT|QUICKSORTMEDIANA|SHELLSORT|MERGESORT\n");
     exit(-1);
  }
  
  nomeArquivoOrigem = argv[1];
  metodoOrdenacao = argv[2];

  leArquivoOrigem(nomeArquivoOrigem, &vetor, &qtdePosicao);

  if (strcmp(metodoOrdenacao,"SELECAO")==0){
     selecao(vetor,qtdePosicao);
  }else if (strcmp(metodoOrdenacao,"BOLHA")==0){
     bolha(vetor,qtdePosicao);
  }else if (strcmp(metodoOrdenacao,"INSERCAO")==0){
     insercao(vetor,qtdePosicao);
  }else{
     printf("METODO DE ORDENACAO INVALIDO.");
     exit(-1);
  }
  
  if((rc = getrusage(RUSAGE_SELF, &resources)) != 0)
     perror("getrusage failed");

   utime = (double) (resources.ru_utime.tv_sec) + 1.e-6 * (double) (resources.ru_utime.tv_usec);
   stime = (double) (resources.ru_stime.tv_sec) + 1.e-6 * (double) (resources.ru_stime.tv_usec);
   total_time = utime+stime;

   if (qtdePosicao==30000){
	total_time -= 0.00900; //Tempo aproximado da leitura do arquivo
   }else if (qtdePosicao==100000){
   	total_time -= 0.03600; //Tempo aproximado da leitura do arquivo
   }
  
  printf("%d;%d;%.5f\n",qtdePosicao,vetor[0],total_time);

  return 0;
}

/*
 * Mtodo que l o arquivo de origem e preenche o vetor e o atributo
 * quantidade de posicao.
 */
void leArquivoOrigem(char *nomeArquivoOrigem, int** vetor, int *qtdePosicao){
  FILE* arquivoOrigem;
  int i;
  
  //Abre o arquivo de Origem
  if ((arquivoOrigem = fopen(nomeArquivoOrigem, "r")) == NULL){
     printf("O ARQUIVO %s NAO PODE SER ABERTO.\n",nomeArquivoOrigem);
     exit(-1);
  }
  
  //L a quantidade de registros
  if (!fscanf(arquivoOrigem,"%d\n",qtdePosicao)){
	printf("Erro: (-1)");
	exit(-1);
  } 

  *vetor = (int*) malloc((*qtdePosicao+1)*sizeof(int));
  (*vetor)[0] = 0;
  for (i=1;i<=*qtdePosicao;i++){
	//L os registros para o vetor
	if (!fscanf(arquivoOrigem,"%d ",&((*vetor)[i]))){
		printf("Erro: (-1)");
		exit(-1);
	} 
  }

  fclose(arquivoOrigem); //Fecha o arquivo de Origem
}


/*SELECAO - INICIO*/
void selecao(int* vetor, int qtdePosicao){
     int i,j,min,aux;
     for (i=1; i<=qtdePosicao-1;i++){
         min = i;
         for (j=i+1;j<=qtdePosicao;j++){
             //numeroComparacoes++; //Debug
             if (vetor[j]<vetor[min]){
                min = j;
             }
         }
         //numeroTrocas+=3; //Debug
         aux = vetor[min];
         vetor[min] = vetor[i];
         vetor[i] = aux;
     }
}
/*SELECAO - TERMINO*/


/*BOLHA - INICIO*/
void bolha(int* vetor, int qtdePosicao){
     int i,j,min,aux;
     for (i=1; i<=qtdePosicao-1;i++){
         for (j=i+1;j<=qtdePosicao;j++){
             //numeroComparacoes++; //Debug
             if (vetor[j]<vetor[i]){
                aux = vetor[j];
                vetor[j] = vetor[i];
                vetor[i] = aux;
                //numeroTrocas+=3; //Debug                
             }
         }
     }
}
/*BOLHA - TERMINO*/


/*INSERCAO - INICIO*/
void insercao(int* vetor, int qtdePosicao){
     int i,j,aux;
     for (i=2; i<=qtdePosicao;i++){
         aux = vetor[i];
         j = i-1;
         vetor[0] =  aux; /*Sentinela*/
         //numeroTrocas+=2; //Debug
         while(aux<vetor[j]){ //Debug
             vetor[j+1] = vetor[j]; 
             //numeroTrocas++; //Debug
             j--;
         }
         vetor[j+1] = aux;
         //numeroTrocas++; //Debug
     }
}
/*INSERCAO - TERMINO*/

