#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <sys/resource.h>

int op=0;

void leArquivoOrigem(char *nomeArquivoOrigem, int** vetor, int *qtdePosicao);

int sequencial(int* vetor, int qtdePosicao, int valorProcurado);

int main(int argc, char *argv[]){
  char *nomeArquivoOrigem;
  int qtdePosicao;
  int valorProcurado;
  int* vetor;
  int result;
  struct rusage resources;
  int rc,i;
  double utime, stime, total_time;
	   
  if (argc!=4){
     printf("USO: PESQUISAR <NOME_ARQUIVO_ORIGEM> <METODO_PESQUISA> <NMERO>.\n");     
     printf("     <METODO_ORDENACAO>: SEQUENCIAL|BINARIA\n");
     exit(-1);
  }
  
  nomeArquivoOrigem = argv[1];
  valorProcurado = atoi(argv[3]);
	
  leArquivoOrigem(nomeArquivoOrigem, (int**)&vetor, (int*)&qtdePosicao);
	
   for (i=0; i<100;++i){ //Para ser 100g
		result = sequencial(vetor,qtdePosicao,valorProcurado+45);
	}
	
	if((rc = getrusage(RUSAGE_SELF, &resources)) != 0)
		perror("getrusage failed");
	
	utime = (double) (resources.ru_utime.tv_sec) + 1.e-6 * (double) (resources.ru_utime.tv_usec);
	stime = (double) (resources.ru_stime.tv_sec) + 1.e-6 * (double) (resources.ru_stime.tv_usec);
	total_time = utime+stime;
	
  if (qtdePosicao==1000000){
  	total_time -= 0.41602; //Tempo aproximado da leitura do arquivo
  }
  
	printf("%d;%d;%.5f\n",op,result,total_time);
  return 0;
}

/*
 * Mtodo que l o arquivo de origem e preenche o vetor e o atributo
 * quantidade de posicao.
 */
void leArquivoOrigem(char *nomeArquivoOrigem, int** vetor, int *qtdePosicao){
  FILE* arquivoOrigem;
  int i;
  
  //Abre o arquivo de Origem
  if ((arquivoOrigem = fopen(nomeArquivoOrigem, "r")) == NULL){
     printf("O ARQUIVO %s NAO PODE SER ABERTO.\n",nomeArquivoOrigem);
     exit(-1);
  }

  //L a quantidade de registros
  if (!fscanf(arquivoOrigem,"%d\n",qtdePosicao)){
  	printf("Erro: (-1)");
	exit(-1);
  }

  *vetor = (int*) malloc((*qtdePosicao+1)*sizeof(int));
  (*vetor)[0] = 0;
  for (i=1;i<=*qtdePosicao;i++){
	//L os registros para o vetor
  	if (!fscanf(arquivoOrigem,"%d ",&((*vetor)[i]))){
  		printf("Erro: (-1)");
		exit(-1);	
	}
  }
  
  fclose(arquivoOrigem); //Fecha o arquivo de Origem
}


int sequencial(int* vetor, int qtdePosicao, int valorProcurado){
	int i;
	int *p = vetor;
	for (i=0; i<qtdePosicao; i++, p++) {
		op++;
		if (*p==valorProcurado){
			return i;
		}
	}
	return -1;
}
