fib40=false;
fib45=false;
selecao30=false;
selecao100=false;
bolha30=false;
bolha100=false;
insercao30=true;
insercao100=true;
sequencial=false;
multint=false;
multdouble=false;
cp=false;
cpnio=false;

if [ -z $1 ] || [ -z $2 ]; then
	echo 'Uso: scriptGeral <Java/C/All> <n>';
else
	lang="$1";
	n=$2;

	echo =========================
	echo 'LINGUAGEM:' $lang
	echo 'N: ' $n
	echo =========================

	#Apaga e cria diretorio
	rm -f -r tmp
	mkdir tmp

	if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
		echo '== CC++ ==';
		gcc -v
		
		cp *.c tmp
		cd tmp
		
		echo 'Compilando...'
		gcc -c -O3 fib.c
		gcc --W1 --stack=33554432 --heap=33554432 --g0 fib.o -o fib

		gcc -c -O3 ordenar.c
		gcc --W1 --stack=33554432 --heap=33554432 --g0 ordenar.o -o ordenar

		gcc -c -O3 pesquisar.c
		gcc --W1 --stack=33554432 --heap=33554432 --g0 pesquisar.o -o pesquisar

		gcc -c -O3 multint.c
		gcc --W1 --stack=33554432 --heap=33554432 --g0 multint.o -o multint

		gcc -c -O3 multdouble.c
		gcc --W1 --stack=33554432 --heap=33554432 --g0 multdouble.o -o multdouble

		gcc -c -O3 io.c
		gcc --W1 --stack=33554432 --heap=33554432 --g0 io.o -o io
		
		cd ..
	fi

	if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
		echo '== JAVA =='; 
		java -version
		javac -version

		cp *.java tmp
		cd tmp

		echo 'Compilando...'
		javac -g:none -Xlint:none -J-Xss33554432 -J-Xms33554432 -J-Xmx33554432 Fib.java

		javac -g:none -Xlint:none -J-Xss33554432 -J-Xms33554432 -J-Xmx33554432 Ordenar.java

		javac -g:none -Xlint:none -J-Xss33554432 -J-Xms33554432 -J-Xmx33554432 Pesquisar.java

		javac -g:none -Xlint:none -J-Xss33554432 -J-Xms33554432 -J-Xmx33554432 MultDouble.java

		javac -g:none -Xlint:none -J-Xss33554432 -J-Xms33554432 -J-Xmx33554432 MultInt.java

		javac -g:none -Xlint:none -J-Xss33554432 -J-Xms33554432 -J-Xmx33554432 IO.java

		javac -g:none -Xlint:none -J-Xss33554432 -J-Xms33554432 -J-Xmx33554432 NIO.java
		
		cd ..
	fi

	#Posiciona no diretorio
	cd tmp

	if ($fib40); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'FIB 40 (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./fib 40
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'FIB 40 (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch -Xss33554432 -Xms33554432 -Xmx33554432 Fib 40
			done
		fi
	fi
	echo
	if ($fib45); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'FIB 45 (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./fib 45
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'FIB 45 (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch -Xss33554432 -Xms33554432 -Xmx33554432 Fib 45
			done
		fi
	fi
	echo
	if ($selecao30); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'SELECAO 30 (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./ordenar ../v30000.txt SELECAO
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'SELECAO 30 (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch -Xss33554432 -Xms33554432 -Xmx33554432 Ordenar ../v30000.txt SELECAO
			done
		fi
	fi
	echo
	if ($selecao100); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'SELECAO 100 (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./ordenar ../v100000.txt SELECAO
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'SELECAO 100 (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch -Xss33554432 -Xms33554432 -Xmx33554432 Ordenar ../v100000.txt SELECAO
			done
		fi
	fi
	echo
	if ($bolha30); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'BOLHA 30 (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./ordenar ../v30000.txt BOLHA
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'BOLHA 30 (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch -Xss33554432 -Xms33554432 -Xmx33554432 Ordenar ../v30000.txt BOLHA
			done
		fi
	fi
	echo
	if ($bolha100); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'BOLHA 100 (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./ordenar ../v100000.txt BOLHA
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'BOLHA 100 (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch -Xss33554432 -Xms33554432 -Xmx33554432 Ordenar ../v100000.txt BOLHA
			done
		fi
	fi
	echo
	if ($insercao30); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'INSERCAO 30 (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./ordenar ../v30000.txt INSERCAO
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'INSERCAO 30 (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch -Xss33554432 -Xms33554432 -Xmx33554432 Ordenar ../v30000.txt INSERCAO
			done
		fi
	fi
	echo
	if ($insercao100); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'INSERCAO 100 (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./ordenar ../v100000.txt INSERCAO
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'INSERCAO 100 (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch -Xss33554432 -Xms33554432 -Xmx33554432 Ordenar ../v100000.txt INSERCAO
			done
		fi
	fi
	echo
	if ($sequencial); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'SEQUENCIAL (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./pesquisar ../v1000000.txt SEQUENCIAL 1
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'SEQUENCIAL (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch Pesquisar ../v1000000.txt SEQUENCIAL 1
			done
		fi
	fi
	echo
	if ($multint); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'MULT INT (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./multint 800
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'MULT INT (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch MultInt 800
			done
		fi
	fi
	echo
	if ($multdouble); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'MULT DOUBLE (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./multdouble 800
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'MULT DOUBLE (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch MultDouble 800
			done
		fi
	fi
	echo
	if ($cp); then
		if [ "$lang" = 'C' ] || [ "$lang" = 'All' ]; then 
			echo 'CP (C)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				./io ../letras30.txt
			done
		fi
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'CP (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch IO ../file.bin
			done
		fi
	fi
	echo
	if ($cpnio); then
		if [ "$lang" = 'Java' ] || [ "$lang" = 'All' ]; then 
			echo 'CP NIO (Java)'
			for (( i = 1 ;  i <= $n;  i++ )) do
				java -dsa -server -Xbatch NIO ../file.bin
			done
		fi
	fi
	
	echo 'Experimentos Finalizados.'
	#Voltando ao diretorio
	cd ..
fi