#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/resource.h>

long int fat(int n){
     if (n==0 || n==1){
        return 1;         
     }
     return n * fat(n-1);
}

long int fib(int n){
	if (n==0 || n==1){
        return n;         
	}
	return fib(n-1) + fib(n-2);
}

/*SELECAO - INICIO*/
void selecao(int* vetor, int qtdePosicao){
	int i, j, min, aux;
	for (i = 0; i < qtdePosicao; i++) {
		min = i;
		for (j = i + 1; j < qtdePosicao-1; j++) {
			if (vetor[j] < vetor[min]) {
				min = j;
			}
		}
		aux = vetor[min];
		vetor[min] = vetor[i];
		vetor[i] = aux;
		}
}
/*SELECAO - TERMINO*/

int sequencial(int* vetor, int qtdePosicao, int valorProcurado){
	int i;
	int *p = vetor;
	for (i=0; i<qtdePosicao; i++, p++) {
		if (*p==valorProcurado){
			return i;
		}
	}
	return -1;
}

void mult(int v1[200][200], int v2[200][200], int res[200][200]) {
	int i, j, k, TAM = 200;
	
	for (i = 0; i < TAM; i++) {
		for (j = 0; j < TAM; j++) {
			res[i][j] = 0;
			for (k = 0; k < TAM; k++) {
				res[i][j] += v1[i][k] * v2[k][j];
			}
		}
	}
}

void inicializa(int v1[200][200], int v2[200][200]) {
	int i,j,count=0;
	for (i=0; i<200; i++){
		for (j=0; j<200; j++){
			int aux = ++count%30;
			v1[i][j] = fat(aux);
			v2[i][j] = fib(aux);
		}
	}
}



int main (int argc, char** argv){
    struct rusage resources;
    int rc;
    double utime, stime, total_time;
	srand ( time(NULL) );

    int v1[200][200];
	int v2[200][200];
	int res[200][200];
	int vetor[40000];
	int count = 0;
	int tam = sizeof(vetor)/sizeof(int);
	int i, j;
	
	inicializa(v1,v2);
	
	mult(v1, v2, res);
	
	for (i=0; i<200; i++){
		for (j=0; j<200; j++){
			vetor[count++] = res[i][j];
		}
	}
	
	selecao(vetor, tam);
	
	int x = sequencial(vetor, tam, 19);
	
	printf("%d;",x);

    
    if((rc = getrusage(RUSAGE_SELF, &resources)) != 0)
        perror("getrusage failed");

    utime = (double) resources.ru_utime.tv_sec + 1.e-6 * (double) resources.ru_utime.tv_usec;
    stime = (double) resources.ru_stime.tv_sec + 1.e-6 * (double) resources.ru_stime.tv_usec;
    total_time = utime+stime;
    printf("%.5lf\n",total_time);

    return 0;
}
